diff --git a/game/client/src/main/java/org/useless/util/GsonHelper.java b/game/client/src/main/java/org/useless/util/GsonHelper.java
new file mode 100644
index 000000000..08d5e7129
--- /dev/null
+++ b/game/client/src/main/java/org/useless/util/GsonHelper.java
@@ -0,0 +1,132 @@
+package org.useless.util;
+
+import com.google.gson.JsonArray;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonPrimitive;
+import org.jetbrains.annotations.NotNull;
+
+@SuppressWarnings("unused")
+public final class GsonHelper {
+    private GsonHelper() {}
+
+    public static float[] getAsFloatArray(@NotNull JsonElement element, int expectedSize) throws JsonParseException {
+        if (!element.isJsonArray()) throw new JsonParseException("Provided element is not a jsonArray! " + element);
+        JsonArray arr = element.getAsJsonArray();
+        if (arr.size() != expectedSize) throw new JsonParseException("Provided array is of size '" + arr.size() + "' not expected size of '" + expectedSize + "'!");
+        float[] returnArr = new float[expectedSize];
+        for (int i = 0; i < expectedSize; i++) {
+            JsonElement e = arr.get(i);
+            if (!e.isJsonPrimitive()) throw new JsonParseException("Element '" + i + "' in array is not a number!");
+            JsonPrimitive p = e.getAsJsonPrimitive();
+            if (!p.isNumber()) throw new JsonParseException("Element '" + i + "' in array is not a number!");
+            returnArr[i] = p.getAsFloat();
+        }
+        return returnArr;
+    }
+
+    public static double[] getAsDoubleArray(@NotNull JsonElement element, int expectedSize) throws JsonParseException {
+        if (!element.isJsonArray()) throw new JsonParseException("Provided element is not a jsonArray! " + element);
+        JsonArray arr = element.getAsJsonArray();
+        if (arr.size() != expectedSize) throw new JsonParseException("Provided array is of size '" + arr.size() + "' not expected size of '" + expectedSize + "'!");
+        double[] returnArr = new double[expectedSize];
+        for (int i = 0; i < expectedSize; i++) {
+            JsonElement e = arr.get(i);
+            if (!e.isJsonPrimitive()) throw new JsonParseException("Element '" + i + "' in array is not a number!");
+            JsonPrimitive p = e.getAsJsonPrimitive();
+            if (!p.isNumber()) throw new JsonParseException("Element '" + i + "' in array is not a number!");
+            returnArr[i] = p.getAsDouble();
+        }
+        return returnArr;
+    }
+
+    public static long[] getAsLongArray(@NotNull JsonElement element, int expectedSize) throws JsonParseException {
+        if (!element.isJsonArray()) throw new JsonParseException("Provided element is not a jsonArray! " + element);
+        JsonArray arr = element.getAsJsonArray();
+        if (arr.size() != expectedSize) throw new JsonParseException("Provided array is of size '" + arr.size() + "' not expected size of '" + expectedSize + "'!");
+        long[] returnArr = new long[expectedSize];
+        for (int i = 0; i < expectedSize; i++) {
+            JsonElement e = arr.get(i);
+            if (!e.isJsonPrimitive()) throw new JsonParseException("Element '" + i + "' in array is not a number!");
+            JsonPrimitive p = e.getAsJsonPrimitive();
+            if (!p.isNumber()) throw new JsonParseException("Element '" + i + "' in array is not a number!");
+            returnArr[i] = p.getAsLong();
+        }
+        return returnArr;
+    }
+
+    public static int[] getAsIntArray(@NotNull JsonElement element, int expectedSize) throws JsonParseException {
+        if (!element.isJsonArray()) throw new JsonParseException("Provided element is not a jsonArray! " + element);
+        JsonArray arr = element.getAsJsonArray();
+        if (arr.size() != expectedSize) throw new JsonParseException("Provided array is of size '" + arr.size() + "' not expected size of '" + expectedSize + "'!");
+        int[] returnArr = new int[expectedSize];
+        for (int i = 0; i < expectedSize; i++) {
+            JsonElement e = arr.get(i);
+            if (!e.isJsonPrimitive()) throw new JsonParseException("Element '" + i + "' in array is not a number!");
+            JsonPrimitive p = e.getAsJsonPrimitive();
+            if (!p.isNumber()) throw new JsonParseException("Element '" + i + "' in array is not a number!");
+            returnArr[i] = p.getAsInt();
+        }
+        return returnArr;
+    }
+
+    public static short[] getAsShortArray(@NotNull JsonElement element, int expectedSize) throws JsonParseException {
+        if (!element.isJsonArray()) throw new JsonParseException("Provided element is not a jsonArray! " + element);
+        JsonArray arr = element.getAsJsonArray();
+        if (arr.size() != expectedSize) throw new JsonParseException("Provided array is of size '" + arr.size() + "' not expected size of '" + expectedSize + "'!");
+        short[] returnArr = new short[expectedSize];
+        for (int i = 0; i < expectedSize; i++) {
+            JsonElement e = arr.get(i);
+            if (!e.isJsonPrimitive()) throw new JsonParseException("Element '" + i + "' in array is not a number!");
+            JsonPrimitive p = e.getAsJsonPrimitive();
+            if (!p.isNumber()) throw new JsonParseException("Element '" + i + "' in array is not a number!");
+            returnArr[i] = p.getAsShort();
+        }
+        return returnArr;
+    }
+
+    public static byte[] getAsByteArray(@NotNull JsonElement element, int expectedSize) throws JsonParseException {
+        if (!element.isJsonArray()) throw new JsonParseException("Provided element is not a jsonArray! " + element);
+        JsonArray arr = element.getAsJsonArray();
+        if (arr.size() != expectedSize) throw new JsonParseException("Provided array is of size '" + arr.size() + "' not expected size of '" + expectedSize + "'!");
+        byte[] returnArr = new byte[expectedSize];
+        for (int i = 0; i < expectedSize; i++) {
+            JsonElement e = arr.get(i);
+            if (!e.isJsonPrimitive()) throw new JsonParseException("Element '" + i + "' in array is not a number!");
+            JsonPrimitive p = e.getAsJsonPrimitive();
+            if (!p.isNumber()) throw new JsonParseException("Element '" + i + "' in array is not a number!");
+            returnArr[i] = p.getAsByte();
+        }
+        return returnArr;
+    }
+
+    public static boolean[] getAsBooleanArray(@NotNull JsonElement element, int expectedSize) throws JsonParseException {
+        if (!element.isJsonArray()) throw new JsonParseException("Provided element is not a jsonArray! " + element);
+        JsonArray arr = element.getAsJsonArray();
+        if (arr.size() != expectedSize) throw new JsonParseException("Provided array is of size '" + arr.size() + "' not expected size of '" + expectedSize + "'!");
+        boolean[] returnArr = new boolean[expectedSize];
+        for (int i = 0; i < expectedSize; i++) {
+            JsonElement e = arr.get(i);
+            if (!e.isJsonPrimitive()) throw new JsonParseException("Element '" + i + "' in array is not a boolean!");
+            JsonPrimitive p = e.getAsJsonPrimitive();
+            if (!p.isBoolean()) throw new JsonParseException("Element '" + i + "' in array is not a boolean!");
+            returnArr[i] = p.getAsBoolean();
+        }
+        return returnArr;
+    }
+
+    public static String[] getAsStringArray(@NotNull JsonElement element, int expectedSize) throws JsonParseException {
+        if (!element.isJsonArray()) throw new JsonParseException("Provided element is not a jsonArray! " + element);
+        JsonArray arr = element.getAsJsonArray();
+        if (arr.size() != expectedSize) throw new JsonParseException("Provided array is of size '" + arr.size() + "' not expected size of '" + expectedSize + "'!");
+        String[] returnArr = new String[expectedSize];
+        for (int i = 0; i < expectedSize; i++) {
+            JsonElement e = arr.get(i);
+            if (!e.isJsonPrimitive()) throw new JsonParseException("Element '" + i + "' in array is not a string!");
+            JsonPrimitive p = e.getAsJsonPrimitive();
+            if (!p.isString()) throw new JsonParseException("Element '" + i + "' in array is not a string!");
+            returnArr[i] = p.getAsString();
+        }
+        return returnArr;
+    }
+}
diff --git a/game/client/src/test/java/TestItemModelDispatcher.java b/game/client/src/test/java/TestItemModelDispatcher.java
index c437ee87e..d976a6a88 100644
--- a/game/client/src/test/java/TestItemModelDispatcher.java
+++ b/game/client/src/test/java/TestItemModelDispatcher.java
@@ -25,7 +25,7 @@ public class TestItemModelDispatcher {
         Colors.loadDummyColors();
 
         // Map model requires mc font reference
-        Minecraft mc = new Minecraft();
+        Minecraft mc = new Minecraft(null,true);
         mc.gameSettings = new GameSettings(mc, mc.getMinecraftDir());
         mc.texturePackList = new TexturePackList(mc, mc.getMinecraftDir());
         mc.textureManager = new TextureManager(mc, mc.texturePackList, mc.gameSettings);
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java b/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java
index 6c6afcc1f..c8246ab29 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java
@@ -58,10 +58,10 @@ public class Achievement extends Stat
     {
         if(statStringFormatter != null)
         {
-            return statStringFormatter.formatString(I18n.getInstance().translateDescKey(description));
+            return statStringFormatter.formatString(I18n.getInstance().translateKey(description + ".desc"));
         } else
         {
-            return I18n.getInstance().translateDescKey(description);
+            return I18n.getInstance().translateKey(description + ".desc");
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/Block.java b/game/core/src/main/java/net/minecraft/core/block/Block.java
index c39207287..5a6044ada 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Block.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Block.java
@@ -455,7 +455,7 @@ public final class Block<T extends BlockLogic>
     @Override
     public void onBlockPlacedByWorld(World world, int x, int y, int z) {
         if (isEntityTile && !disableNormalEntityLogic && entitySupplier != null) {
-            world.setBlockTileEntity(x, y, z, entitySupplier.get());
+            world.setTileEntity(x, y, z, entitySupplier.get());
         }
         logic.onBlockPlacedByWorld(world, x, y, z);
     }
@@ -465,7 +465,7 @@ public final class Block<T extends BlockLogic>
         logic.onBlockRemoved(world, x, y, z, data);
         if (isEntityTile && !disableNormalEntityLogic) {
             if (!world.isClientSide) {
-                TileEntity tileEntity = world.getBlockEntity(x, y, z);
+                TileEntity tileEntity = world.getTileEntity(x, y, z);
                 if(tileEntity != null) {
                     tileEntity.dropContents(world, x, y, z);
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
index 1a7108d55..cfa71e5c2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
@@ -31,8 +31,8 @@ public class BlockLogicActivator extends BlockLogicVeryRotatable
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         if (!world.isClientSide) {
-            TileEntityActivator dispenserBlockEntity = (TileEntityActivator) world.getBlockEntity(x, y, z);
-            player.displayActivatorScreen(dispenserBlockEntity);
+            TileEntityActivator tileEntityActivator = (TileEntityActivator) world.getTileEntity(x, y, z);
+            player.displayActivatorScreen(tileEntityActivator);
         }
         return true;
     }
@@ -44,7 +44,7 @@ public class BlockLogicActivator extends BlockLogicVeryRotatable
         int yOffset = direction.getOffsetY();
         int zOffset = direction.getOffsetZ();
 
-        TileEntityActivator activator = (TileEntityActivator)world.getBlockEntity(x, y, z);
+        TileEntityActivator activator = (TileEntityActivator)world.getTileEntity(x, y, z);
         if (!activator.locked(activator.stackSelector)) {
             ItemStack itemStack = activator.getNextStack();
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
index 5fe216bcb..1b8ffb04e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
@@ -23,7 +23,7 @@ public class BlockLogicBasket extends BlockLogic
     @Override
     public boolean onBlockRightClicked(final World world, final int x, final int y, final int z, final Player entityplayer, Side side, double xPlaced, double yPlaced)
     {
-        final TileEntityBasket te = (TileEntityBasket) world.getBlockEntity(x, y, z);
+        final TileEntityBasket te = (TileEntityBasket) world.getTileEntity(x, y, z);
 
         if (te.getNumUnitsInside() > 0)
         {
@@ -37,7 +37,7 @@ public class BlockLogicBasket extends BlockLogic
 
     @Override
     public void onActivatorInteract(World world, int x, int y, int z, TileEntityActivator activator, Direction direction) {
-        final TileEntityBasket te = (TileEntityBasket) world.getBlockEntity(x, y, z);
+        final TileEntityBasket te = (TileEntityBasket) world.getTileEntity(x, y, z);
 
         if (te.getNumUnitsInside() > 0)
         {
@@ -52,7 +52,7 @@ public class BlockLogicBasket extends BlockLogic
 
     public int getFillLevel(final WorldSource world, final int x, final int y, final int z)
     {
-        final TileEntityBasket te = (TileEntityBasket) world.getBlockEntity(x, y, z);
+        final TileEntityBasket te = (TileEntityBasket) world.getTileEntity(x, y, z);
 
         final float fill = te.getNumUnitsInside() / (float)te.getMaxUnits();
 
@@ -80,7 +80,7 @@ public class BlockLogicBasket extends BlockLogic
     @Override
     public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side)
     {
-        TileEntityBasket basketTileEntity = (TileEntityBasket) worldSource.getBlockEntity(x, y, z);
+        TileEntityBasket basketTileEntity = (TileEntityBasket) worldSource.getTileEntity(x, y, z);
         if(basketTileEntity != null){
             return basketTileEntity.getNumUnitsInside() == basketTileEntity.getMaxUnits();
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
index c62c3d4c6..0a43f9201 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
@@ -5,7 +5,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.vehicle.EntityBoat;
-import net.minecraft.core.entity.vehicle.MinecartEntity;
+import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.ItemStack;
@@ -126,7 +126,7 @@ public class BlockLogicCactus extends BlockLogic implements IBonemealable
     @Override
     public void onEntityCollidedWithBlock(World world, int x, int y, int z, Entity entity)
     {
-        if(entity instanceof Mob || entity instanceof MinecartEntity || entity instanceof EntityBoat) {
+        if(entity instanceof Mob || entity instanceof EntityMinecart || entity instanceof EntityBoat) {
         	entity.hurt(null, 1, DamageType.COMBAT);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
index c5ce4404e..9c081b1cf 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
@@ -313,7 +313,7 @@ public class BlockLogicChest extends BlockLogic implements IPaintable {
 	}
 	
 	public static Container getInventory(World world, int x, int y, int z) {
-		Container inventory = (Container) world.getBlockEntity(x, y, z);
+		Container inventory = (Container) world.getTileEntity(x, y, z);
 
         int meta = world.getBlockMetadata(x, y, z);
 		Type type = getTypeFromMeta(meta);
@@ -348,11 +348,11 @@ public class BlockLogicChest extends BlockLogic implements IPaintable {
 				if(getDirectionFromMeta(otherMeta) == direction) {
 					Type otherType = getTypeFromMeta(otherMeta);
 					if(type == Type.LEFT && otherType == Type.RIGHT) {
-						inv2 = (Container) world.getBlockEntity(otherChestX, y, otherChestZ);
+						inv2 = (Container) world.getTileEntity(otherChestX, y, otherChestZ);
 					}
 					if(type == Type.RIGHT && otherType == Type.LEFT) {
 						inv2 = inventory;
-						inventory = (Container) world.getBlockEntity(otherChestX, y, otherChestZ);
+						inventory = (Container) world.getTileEntity(otherChestX, y, otherChestZ);
 					}
 				}
 			}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestLegacy.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestLegacy.java
index 6824d42a4..4161e5036 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestLegacy.java
@@ -36,7 +36,7 @@ public class BlockLogicChestLegacy extends BlockLogic {
 	
 	@Override
 	public void onBlockRemoved(World world, int x, int y, int z, int data) {
-		TileEntity entity = world.getBlockEntity(x, y, z);
+		TileEntity entity = world.getTileEntity(x, y, z);
 		if (entity != null) {
 			entity.dropContents(world, x, y, z);
 		}
@@ -174,7 +174,7 @@ public class BlockLogicChestLegacy extends BlockLogic {
 	}
 	
 	private ItemStack[] getAndClearChestInventory(World world, int x, int y, int z) {
-		TileEntityChest tileEntityChest = (TileEntityChest) world.getBlockEntity(x, y, z);
+		TileEntityChest tileEntityChest = (TileEntityChest) world.getTileEntity(x, y, z);
 		
 		ItemStack[] items = new ItemStack[tileEntityChest.getContainerSize()];
 		
@@ -187,7 +187,7 @@ public class BlockLogicChestLegacy extends BlockLogic {
 	}
 	
 	private void setChestInventory(World world, int x, int y, int z, ItemStack[] items) {
-		TileEntityChest tileEntityChest = (TileEntityChest) world.getBlockEntity(x, y, z);
+		TileEntityChest tileEntityChest = (TileEntityChest) world.getTileEntity(x, y, z);
 		
 		for(int i=0; i < items.length; i++) {
 			tileEntityChest.setItem(i, items[i]);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
index da7d5665b..42e6dab32 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
@@ -38,7 +38,7 @@ public class BlockLogicDispenser extends BlockLogicVeryRotatable
             return true;
         } else
         {
-            TileEntityDispenser tileEntityDispenser = (TileEntityDispenser)world.getBlockEntity(x, y, z);
+            TileEntityDispenser tileEntityDispenser = (TileEntityDispenser)world.getTileEntity(x, y, z);
             player.displayDispenserScreen(tileEntityDispenser);
             return true;
         }
@@ -51,7 +51,7 @@ public class BlockLogicDispenser extends BlockLogicVeryRotatable
         int yOffset = direction.getOffsetY();
         int zOffset = direction.getOffsetZ();
 
-        TileEntityDispenser tileEntity = (TileEntityDispenser)world.getBlockEntity(x, y, z);
+        TileEntityDispenser tileEntity = (TileEntityDispenser)world.getTileEntity(x, y, z);
         ItemStack itemStack = tileEntity.getRandomStackFromInventory();
         double px = (double)x + (double)xOffset * 0.6D + 0.5D;
         double py = (double)y + (double)yOffset * 0.6D + 0.5D;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
index 87de3a52e..cd6f60d66 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
@@ -10,6 +10,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.weather.IPrecipitation;
 
 import java.util.Random;
 
@@ -124,7 +125,7 @@ public class BlockLogicFire extends BlockLogic {
 		}
 		
 		//Extinguish fire (Rain / Snow)
-		if (!infiniBurn && world.getCurrentWeather() != null && world.getCurrentWeather().isPrecipitation && (
+		if (!infiniBurn && world.getCurrentWeather() != null && world.getCurrentWeather() instanceof IPrecipitation && (
 				   world.canBlockBeRainedOn(x, y, z)
 				|| world.canBlockBeRainedOn(x - 1, y, z)
 				|| world.canBlockBeRainedOn(x + 1, y, z)
@@ -177,7 +178,7 @@ public class BlockLogicFire extends BlockLogic {
 					}
 					
 					int c = (b + 40) / (meta + 30);
-					if (c <= 0 || rand.nextInt(a) > c || (world.getCurrentWeather() != null && world.getCurrentWeather().isPrecipitation) &&
+					if (c <= 0 || rand.nextInt(a) > c || (world.getCurrentWeather() != null && world.getCurrentWeather() instanceof IPrecipitation) &&
 							   world.canBlockBeRainedOn(x1, y1, z1)
 							|| world.canBlockBeRainedOn(x1 - 1, y1, z)
 							|| world.canBlockBeRainedOn(x1 + 1, y1, z1)
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java
index 1f3bdb28e..acd8067e1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java
@@ -3,6 +3,7 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.weather.IPrecipitation;
 
 import java.util.Random;
 
@@ -22,7 +23,7 @@ public class BlockLogicFireCold extends BlockLogicFire {
         }
 
         //Extinguish fire (Rain / Snow)
-        if (!infiniBurn && world.getCurrentWeather() != null && world.getCurrentWeather().isPrecipitation && (
+        if (!infiniBurn && world.getCurrentWeather() != null && world.getCurrentWeather() instanceof IPrecipitation && (
             world.canBlockBeRainedOn(x, y, z)
                 || world.canBlockBeRainedOn(x - 1, y, z)
                 || world.canBlockBeRainedOn(x + 1, y, z)
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
index 5bcae9e0e..22d4b469a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
@@ -57,7 +57,7 @@ public class BlockLogicFlag extends BlockLogic {
 	@Override
 	public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
 		if (!world.isClientSide) {
-			TileEntityFlag flag = (TileEntityFlag) world.getBlockEntity(x, y, z);
+			TileEntityFlag flag = (TileEntityFlag) world.getTileEntity(x, y, z);
 			if (flag.owner != null && !player.uuid.equals(flag.owner)) {
 				return false;
 			}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java
index bd351d32a..f28006039 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java
@@ -80,7 +80,7 @@ public class BlockLogicFurnace extends BlockLogicRotatable
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         if (!world.isClientSide) {
-            TileEntityFurnace tileentityfurnace = (TileEntityFurnace) world.getBlockEntity(x, y, z);
+            TileEntityFurnace tileentityfurnace = (TileEntityFurnace) world.getTileEntity(x, y, z);
             player.displayFurnaceScreen(tileentityfurnace);
         }
         return true;
@@ -88,7 +88,7 @@ public class BlockLogicFurnace extends BlockLogicRotatable
 
 	public static void updateFurnaceBlockState(boolean lit, @NotNull World world, int x, int y, int z) {
 		int meta = world.getBlockMetadata(x, y, z);
-		TileEntity tileEntity = world.getBlockEntity(x, y, z);
+		TileEntity tileEntity = world.getTileEntity(x, y, z);
 		if(tileEntity == null) {
 			String msg = "Furnace is missing Tile Entity at x: "+x+" y: "+y+" z: "+z+", block will be removed!";
 			if(Global.BUILD_CHANNEL.isUnstableBuild()) {
@@ -107,7 +107,7 @@ public class BlockLogicFurnace extends BlockLogicRotatable
 		keepFurnaceInventory = false;
 		world.setBlockMetadataWithNotify(x, y, z, meta);
 		tileEntity.validate();
-		world.setBlockTileEntity(x, y, z, tileEntity);
+		world.setTileEntity(x, y, z, tileEntity);
 	}
 
     protected Random furnaceRand;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java
index 643132270..85a8210c5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java
@@ -42,7 +42,7 @@ public class BlockLogicFurnaceBlast extends BlockLogicFurnace
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         if (!world.isClientSide) {
-            TileEntityFurnaceBlast furnaceBlast = (TileEntityFurnaceBlast) world.getBlockEntity(x, y, z);
+            TileEntityFurnaceBlast furnaceBlast = (TileEntityFurnaceBlast) world.getTileEntity(x, y, z);
             player.displayFurnaceScreen(furnaceBlast);
         }
         return true;
@@ -85,7 +85,7 @@ public class BlockLogicFurnaceBlast extends BlockLogicFurnace
 
 	public static void updateFurnaceBlockState(boolean lit, World world, int x, int y, int z) {
 		int meta = world.getBlockMetadata(x, y, z);
-		TileEntity tileEntity = world.getBlockEntity(x, y, z);
+		TileEntity tileEntity = world.getTileEntity(x, y, z);
 		if(tileEntity == null) {
 			String msg = "Blast Furnace is missing Tile Entity at x: "+x+" y: "+y+" z: "+z+", block will be removed!";
 			if(Global.BUILD_CHANNEL.isUnstableBuild()) {
@@ -104,7 +104,7 @@ public class BlockLogicFurnaceBlast extends BlockLogicFurnace
 		keepFurnaceInventory = false;
 		world.setBlockMetadataWithNotify(x, y, z, meta);
 		tileEntity.validate();
-		world.setBlockTileEntity(x, y, z, tileEntity);
+		world.setTileEntity(x, y, z, tileEntity);
 	}
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
index 1efef53b4..18e93dacf 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
@@ -62,7 +62,7 @@ public class BlockLogicJar extends BlockLogic {
                     world.dropItem(x, y, z, new ItemStack(itemSupplier.get(), 1, 0));
                 }
             } else {
-                TileEntityFlowerJar tileEntity = (TileEntityFlowerJar) world.getBlockEntity(x, y, z);
+                TileEntityFlowerJar tileEntity = (TileEntityFlowerJar) world.getTileEntity(x, y, z);
                 int flowerInPot = tileEntity.flowerInPot;
                 int flowerData = tileEntity.flowerData;
                 if (flowerInPot > 0 && Blocks.hasTag(flowerInPot, BlockTags.PLANTABLE_IN_JAR)) {
@@ -77,7 +77,7 @@ public class BlockLogicJar extends BlockLogic {
         } else if (player.getHeldItem().getItem() instanceof ItemBlock) {
             Block<?> blockInHand = ((ItemBlock<?>) player.getHeldItem().getItem()).getBlock();
             if (Blocks.hasTag(blockInHand.id(), BlockTags.PLANTABLE_IN_JAR)) {
-                TileEntityFlowerJar tileEntity = (TileEntityFlowerJar) world.getBlockEntity(x, y, z);
+                TileEntityFlowerJar tileEntity = (TileEntityFlowerJar) world.getTileEntity(x, y, z);
                 if(world.getBlockMetadata(x, y, z) == 0) {
                     player.getHeldItem().consumeItem(player);
                     world.setBlockMetadataWithNotify(x, y, z, 1);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
index 9b1844041..622fd8959 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
@@ -41,7 +41,7 @@ public class BlockLogicJukebox extends BlockLogic
     public void playRecord(World world, int x, int y, int z, int recordId)
     {
         if (!world.isClientSide) {
-            TileEntityJukebox jukebox = (TileEntityJukebox) world.getBlockEntity(x, y, z);
+            TileEntityJukebox jukebox = (TileEntityJukebox) world.getTileEntity(x, y, z);
             jukebox.record = recordId;
             jukebox.setChanged();
             world.setBlockMetadataWithNotify(x, y, z, 1);
@@ -54,7 +54,7 @@ public class BlockLogicJukebox extends BlockLogic
         {
             return;
         }
-        TileEntity tileEntity = world.getBlockEntity(x, y, z);
+        TileEntity tileEntity = world.getTileEntity(x, y, z);
         tileEntity.dropContents(world, x, y, z);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
index d8468e00d..6dbe4c92a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
@@ -17,7 +17,7 @@ public class BlockLogicMeshGold extends BlockLogicMesh {
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
-        TileEntityMeshGold meshGold = (TileEntityMeshGold) world.getBlockEntity(x, y, z);
+        TileEntityMeshGold meshGold = (TileEntityMeshGold) world.getTileEntity(x, y, z);
         ItemStack heldItem = player.getHeldItem();
         boolean flag = meshGold.setFilterItem(player, heldItem);
         if(heldItem != null && heldItem.stackSize <= 0)
@@ -30,7 +30,7 @@ public class BlockLogicMeshGold extends BlockLogicMesh {
     @Override
     public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
         if (entity instanceof EntityItem){
-            TileEntityMeshGold mesh = (TileEntityMeshGold) world.getBlockEntity(x, y, z);
+            TileEntityMeshGold mesh = (TileEntityMeshGold) world.getTileEntity(x, y, z);
             if (mesh.filterItem == null) return true;
 
             ItemStack entityStack = ((EntityItem) entity).item;
